<?php

declare(strict_types=1);

namespace Test\Ease;

use Ease\Molecule;

// @codingStandardsIgnoreFile
// @codeCoverageIgnoreStart

/**
 * Generated by PHPUnit_SkeletonGenerator on 2017-09-22 at 07:47:58.
 */
class MoleculeTest extends AtomTest {

    /**
     * @var Molecule
     */
    protected $object;

    /**
     */
    protected function setUp(): void {
        $this->object = new Molecule();
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * t This method is called after a test is executed.
     */
    protected function tearDown(): void {
        
    }

    /**
     * @covers Ease\Molecule::setObjectName
     */
    public function testSetObjectName() {
        $this->object->setObjectName('Testing');
        $this->assertEquals('Testing', $this->object->getObjectName());
        $this->object->setObjectName();
        $this->assertEquals(get_class($this->object),
                $this->object->getObjectName());
    }

    /**
     * @covers Ease\Molecule::getObjectName
     */
    public function testGetObjectName() {
        $this->assertNotEmpty($this->object->getObjectName());
    }

    /**
     * @covers Ease\Molecule::setupProperty
     */
    public function testSetupProperty() {
        if (!defined('OBJNAME')) {
            define('OBJNAME', 'CONSTATNT');
        }

        $this->object->setupProperty(['objectName' => 'Original'], 'objectName', 'OBJNAME');
        $this->assertEquals('Original', $this->object->objectName);

        $this->object->setupProperty(['OBJNAME' => 'Copy'], 'objectName', 'OBJNAME');
        $this->assertEquals('Copy', $this->object->objectName);

        $this->object->objectName = null;
        $this->object->setupProperty(['key' => 'value'], 'objectName', 'OBJNAME');
        $this->assertEquals('CONSTATNT', $this->object->objectName);

        $this->object->setupProperty(['objectName' => 'ARRAY'], 'objectName', 'OBJNAME');
        $this->assertEquals('ARRAY', $this->object->objectName);

        putenv('ENVTEST=TEST');

        $this->object->setupProperty([], 'objectName', 'ENVTEST');
        $this->assertEquals('TEST', $this->object->objectName);
    }

}

// @codeCoverageIgnoreEnd
